~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/extract-ikconfig

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/extract-ikconfig (Version linux-6.12-rc7) and /scripts/extract-ikconfig (Version linux-2.6.0)


  1 #!/bin/sh                                      !!   1 #! /bin/bash 
  2 # -------------------------------------------- !!   2 # extracts .config info from a [b]zImage file
  3 # extract-ikconfig - Extract the .config file  !!   3 # uses: binoffset (new), dd, zcat, strings, grep
  4 #                                              !!   4 # $arg1 is [b]zImage filename
  5 # This will only work when the kernel was comp << 
  6 #                                              << 
  7 # The obscure use of the "tr" filter is to wor << 
  8 # "grep" that report the byte offset of the li << 
  9 #                                              << 
 10 # (c) 2009,2010 Dick Streefland <dick@streeflan << 
 11 # Licensed under the terms of the GNU General  << 
 12 # -------------------------------------------- << 
 13                                                     5 
 14 cf1='IKCFG_ST\037\213\010'                     !!   6 TMPFILE=""
 15 cf2='0123456789'                               << 
 16                                                     7 
 17 dump_config()                                  !!   8 usage()
 18 {                                                   9 {
 19         if      pos=`tr "$cf1\n$cf2" "\n$cf2=" !!  10         echo "  usage: extract-ikconfig [b]zImage_filename"
 20         then                                   << 
 21                 pos=${pos%%:*}                 << 
 22                 tail -c+$(($pos+8)) "$1" | zca << 
 23                 if      [ $? != 1 ]            << 
 24                 then    # exit status must be  << 
 25                         cat $tmp1              << 
 26                         exit 0                 << 
 27                 fi                             << 
 28         fi                                     << 
 29 }                                                  11 }
 30                                                    12 
 31 try_decompress()                               !!  13 clean_up()
 32 {                                                  14 {
 33         for     pos in `tr "$1\n$2" "\n$2=" <  !!  15         if [ -z $ISCOMP ]
 34         do                                     !!  16         then
 35                 pos=${pos%%:*}                 !!  17                 rm -f $TMPFILE
 36                 tail -c+$pos "$img" | $3 > $tm !!  18         fi
 37                 dump_config $tmp2              << 
 38         done                                   << 
 39 }                                                  19 }
 40                                                    20 
 41 # Check invocation:                            !!  21 if [ $# -lt 1 ]
 42 me=${0##*/}                                    !!  22 then
 43 img=$1                                         !!  23         usage
 44 if      [ $# -ne 1 -o ! -s "$img" ]            !!  24         exit
                                                   >>  25 fi
                                                   >>  26 
                                                   >>  27 image=$1
                                                   >>  28 
                                                   >>  29 # There are two gzip headers, as well as arches which don't compress their
                                                   >>  30 # kernel.
                                                   >>  31 GZHDR="0x1f 0x8b 0x08 0x00"
                                                   >>  32 if [ `binoffset $image $GZHDR >/dev/null 2>&1 ; echo $?` -ne 0 ]
                                                   >>  33 then
                                                   >>  34         GZHDR="0x1f 0x8b 0x08 0x08"
                                                   >>  35         if [ `binoffset $image $GZHDR >/dev/null 2>&1 ; echo $?` -ne 0 ]
                                                   >>  36         then
                                                   >>  37                 ISCOMP=0
                                                   >>  38         fi
                                                   >>  39 fi
                                                   >>  40 
                                                   >>  41 PID=$$
                                                   >>  42 
                                                   >>  43 # Extract and uncompress the kernel image if necessary
                                                   >>  44 if [ -z $ISCOMP ]
                                                   >>  45 then
                                                   >>  46         TMPFILE="/tmp/`basename $image`.vmlin.$PID"
                                                   >>  47         dd if=$image bs=1 skip=`binoffset $image $GZHDR` 2> /dev/null | zcat > $TMPFILE
                                                   >>  48 else
                                                   >>  49         TMPFILE=$image
                                                   >>  50 fi
                                                   >>  51 
                                                   >>  52 # Look for strings.
                                                   >>  53 strings $TMPFILE | grep "CONFIG_BEGIN=n" > /dev/null
                                                   >>  54 if [ $? -eq 0 ]
 45 then                                               55 then
 46         echo "Usage: $me <kernel-image>" >&2   !!  56         strings $TMPFILE | awk "/CONFIG_BEGIN=n/,/CONFIG_END=n/" > $image.oldconfig.$PID
 47         exit 2                                 !!  57 else
                                                   >>  58         echo "ERROR: Unable to extract kernel configuration information."
                                                   >>  59         echo "       This kernel image may not have the config info."
                                                   >>  60         clean_up
                                                   >>  61         exit 1
 48 fi                                                 62 fi
 49                                                    63 
 50 # Prepare temp files:                          !!  64 echo "Kernel configuration written to $image.oldconfig.$PID"
 51 tmp1=/tmp/ikconfig$$.1                         !!  65 clean_up
 52 tmp2=/tmp/ikconfig$$.2                         !!  66 exit 0
 53 trap "rm -f $tmp1 $tmp2" 0                     << 
 54                                                << 
 55 # Initial attempt for uncompressed images or o << 
 56 dump_config "$img"                             << 
 57                                                << 
 58 # That didn't work, so retry after decompressi << 
 59 try_decompress '\037\213\010' xy    gunzip     << 
 60 try_decompress '\3757zXZ\000' abcde unxz       << 
 61 try_decompress 'BZh'          xy    bunzip2    << 
 62 try_decompress '\135\0\0\0'   xxx   unlzma     << 
 63 try_decompress '\211\114\132' xy    'lzop -d'  << 
 64 try_decompress '\002\041\114\030' xyy 'lz4 -d  << 
 65 try_decompress '\050\265\057\375' xxx unzstd   << 
 66                                                << 
 67 # Bail out:                                    << 
 68 echo "$me: Cannot find kernel config." >&2     << 
 69 exit 1                                         << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php